// LightWave Modeler Script
// Ver. 0.696969
// Purpose: To select multiple Parts at once.
// Usage: Don't be shy! but You'd better try with small data first.
// Note: I Am Not Responsible for Any Damage on Your Intellectual Data!!
// Author:   ATSURO SETO ArturoSeth@gmail.com
// URL:       http://www.cc.rim.or.jp/~atsuro/

@version 2.6
@warnings
@name sel_Multi_Parts

//var selPolysPrev;
                     
var offsetToPart0=0;
var surfTagsSize;
var iLoL;
var sErr, sErr2;
var str1stSURF;
var bytesNowHere=0;
var vmap;
var Tags=nil;
var iLongestTag;
var iLongestName=1;
var partsArray;
var p;

var sPolysSelected="0";
var sTimeElapsed="";
var polysResults[1];

var x, y, z, i, j, w, h;
var cVPort, cTxtNodes, cHelpBtn, cInfoBtn;
var cSearchStr, cMarkBtn, cClearBtn, cSelPolysBtn;
var t, t2;

var gSel=nil;//[1];
var startItem=0;
var endItem=0;
var sCSA, sLMR, sRowNum;
var iMouCount;
var lineNum;

var strFirst="^.+$";
var global_expr;
var sS, sV;
var intContains=0;
var intNotContains;

var reqW=200;
var dynH;
var vpTextW;
var iCanvW, iCanvH;
var gInfo=false;
var done=false;
var isTheEnd=false;

var eachRowH=16;
var iStrOffsetY=3;
var intRowNum;

main{
	ThisMesh = Mesh(0);
	if(!ThisMesh.polygonCount()){
		error("This object contains No Polygon!");
		return;
	}
	if(!ThisMesh.filename){
		gObjLwoPath=getfile("Save Object As", "Unnamed.lwo", getdir("Objects"), false) || error ("Not saved *.lwo file!<br>", gObjLwoPath);
		save(gObjLwoPath);
		fileexists(gObjLwoPath)||error("file not exists ", gObjLwoPath);
		ThisMesh=Mesh(0);
	}
	gObjLwoPath=ThisMesh.filename;
	(drv,pat,nam,ext)=split(gObjLwoPath);
	gObjTmpPath=(drv+pat+nam+".tmp");
/*
	if(nam==s~._v[0-9][0-9][0-9]$~){
		inc=integer(strright(nam,3));
		//inc++;///////////////////////////////////////////////////////////////////
		sInc=string(inc);
		if(sInc.size()==1)
			sInc="00"+sInc;
		else if(sInc.size()==2)
			sInc="0"+sInc;
		nam=strleft(nam,nam.size() - 3)+sInc;	
		gObjLwoPath=(drv+pat+nam+ext);
	}else
		gObjLwoPath=(drv+pat+nam+"_v001"+ext);
*/		
//	selmode(DIRECT);
//	editbegin();
//	if(polygons){
//		foreach(pid,polygons)
//			selPolysPrev+=pid;
//	}
//	editend();
	
	lyrFGArray=lyrfg();//Which layers are selected?
	lyrsHoldPolys=lyrdata(); //Which layers hold Polygons
	lyrsetfg(lyrsHoldPolys); // Select only the layers hold polys
	
	selmode(USER);
	selpolygon(CLEAR);//To put one and only part on ALL of polys
	changepart(" ");
	save(gObjTmpPath);//Save part with name " ", to separate Sketch Colors and Parts

	undo(); // Cancel the just above changepart(" ")
//	lyrsetfg(lyrFGArray);
	
//	if(selPolysPrev){ // Recover the original selection
//		foreach(pid, selPolysPrev)
//		selpolygon(SET,POLYID,pid);
//	}
//	save(gObjLwoPath);
//debug();
	
	partName0x20File = File(gObjTmpPath,"rb");//read it in binary mode
	filesize=partName0x20File.linecount();
	partName0x20File.offset(17,FROMSTART);
	// 17 //r = 256*256*256*partName0x20File.readByte();//might need a ...
	offsetTagsEnd = 256*256*partName0x20File.readByte();//...but unreasonably huge, ignore
	offsetTagsEnd += 256 * partName0x20File.readByte();//
	offsetTagsEnd += partName0x20File.readByte();
//	moninit(offsetTagsEnd,"Reading Binary");
	bytesNowHere+=20;
	offsetTagsEnd+=bytesNowHere;
	strTags="";
	surfIsComingAsNextPair=false;
	for(bytesNowHere;bytesNowHere<offsetTagsEnd;bytesNowHere+=2){
		s1 = partName0x20File.readByte();
//		monstep();
		s2 = partName0x20File.readByte();
//		monstep();
		if(s1!=32 && surfIsComingAsNextPair==false) continue;
		// && surfIsComingAsNextPair=false)continue;
		else{
			if(s1==32){
				surfIsComingAsNextPair=true;
				offsetToPart0=bytesNowHere;
				adrSurfaces0=bytesNowHere+2;
				continue;
			}
			else{
				if(s1 != 0){ //0 is the separater between Names, and each Name end. 
					strTags+=s1.asAsc();
				}else{
					Tags+=strTags;
					strTags="";
					continue;
				} 
				if(s2 !=0){
					strTags+=s2.asAsc();
				}else{
					Tags+=strTags;
					strTags="";
					continue;
				}
				
			}
		}
	}
	iLoL=bytesNowHere; //Here "L" of "LAYR" chunk;
	surfTagsSize=Tags.size();
	Tags=nil;
	partName0x20File.close();
//	debug();
	filedelete(gObjTmpPath); // Delete tmp file.
//	monend();
	save(gObjLwoPath); // Undone and Previous Parts retrieved then Overwrite.

	bytesNowHere=0;
	ThisMesh=Mesh(0);
	BinaryFile = File(ThisMesh.filename,"rb");//read it in binary mode
	filesize=BinaryFile.linecount();
//	moninit(filesize,"Reading Binary");
	BinaryFile.offset(17,FROMSTART);
	// 17 //r = 256*256*256*BinaryFile.readByte();//might need a ...
	offsetTagsEnd = 256*256*BinaryFile.readByte();//...but unreasonably huge, ignore
	offsetTagsEnd += 256 * BinaryFile.readByte();//
	offsetTagsEnd += BinaryFile.readByte();
	bytesNowHere+=20;
	offsetTagsEnd+=bytesNowHere;
	BinaryFile.offset(offsetToPart0,FROSTART);
	bytesNowHere=offsetToPart0;
//	for(i=0; i<bytesNowHere;i++)
//		monstep();
	strTags="";
	for(bytesNowHere;bytesNowHere<offsetTagsEnd;bytesNowHere+=2){
		s1 = BinaryFile.readByte();
//		monstep();
		s2 = BinaryFile.readByte();
//		monstep();
		if(s1 != 0){ //0 is the only separater between Name strings, and each Name end. 
			strTags+=s1.asAsc();
		}else{
			Tags+=strTags;
			strTags="";
			continue;
		} 
		if(s2 !=0){
			strTags+=s2.asAsc();
		}else{
			Tags+=strTags;
			strTags="";
			continue;
		}
	}
	iLoL=bytesNowHere; //Here "L" of "LAYR" chunk;

/*	
	while(!BinaryFile.eof()){
		BinaryFile.offset(3,FROMHERE);//FromHere0"L", 1"A",2"Y",3"R"
		sF=BinaryFile.readByte().asAsc();
		bytesNowHere+=4;
		monstep();monstep();monstep();monstep();
		BinaryFile.offset(1,FROMHERE);//00,00,ff,ff
		offsetToNextTag=256*256*BinaryFile.readByte();
		offsetToNextTag+=256*BinaryFile.readByte();
		offsetToNextTag+=BinaryFile.readByte();
		bytesNowHere+=4;
		monstep();monstep();monstep();monstep();
		if(sF=="F"){
			str1stSURF="";
			for(i=0;i<offsetToNextTag;i++){
				bytesNowHere++;
				monstep();
				s = BinaryFile.readByte();
				if(s != 0) //0 is the end of SURF Name string. 
					str1stSURF+=s.asAsc();
				else
					break;
			}
			for(i=bytesNowHere;i<=BinaryFile.linecount();i++){
				monstep();
			}
			break;
		}else{
			bytesNowHere+=offsetToNextTag;
			BinaryFile.offset(offsetToNextTag,FROMHERE);
			 while(offsetToNextTag){
				 monstep();
				 offsetToNextTag--;
			 }
			if(bytesNowHere>=filesize){
				sErr=string("bytesNowHere: ", bytesNowHere);
				sErr2=string("filesize: ", filesize);
				break;
			}
		}
	}
	*/
	BinaryFile.close();
//	monend();
	partsArray=nil;//"(none)";
	for(i=1;i<=(Tags.size() - surfTagsSize);i++){
		//if(Tags[i]==str1stSURF)break;
		partsArray+=Tags[i];
		if(iLongestName<Tags[i].size()){
			 iLongestName=Tags[i].size();
			 iLongestTag=i;
		}
	}
	if(!partsArray){
		error ("No Part in This Object!<br>", ThisMesh.filename);
		return;
	}
	
//	lyrsetfg(lyrFGArray);
///////////////////////////////////////////////////////////
	reqbegin("sel_Multi_Parts");
	reqsize(reqW,300); 
	
	cVPort =ctlviewport(0,0,"vp_redraw","vp_Canvas_size");
	cTxtNodes =ctlinfo(0,0,"info_redraw");
	cInfoBtn = ctlstate("i", 0, 0, "infoStatus");
	cSearchStr = ctlstring("", strFirst, 190);
	cMarkBtn=ctlbutton("grep",0,"cb_Mark");
	ctlrefresh (cSearchStr , "InputRefresh");
//	cHelpBtn = ctlbutton("?",0, "help");
	cSelPolysBtn = ctlbutton("Shy1",0, "sel_ifMarked");
	cClearBtn = ctlbutton("Shy2",0, "allClear");
	reqresize("resize",200,300,430,480); 
	if (!reqpost()) {
		isTheEnd=true;
		allClear();
		return;
	}
	reqend();
	isTheEnd=true;
	if(!done)sel_ifMarked();
}

resize : w,h{
	ctlposition(cVPort,0,16,w, h - 100);
	ctlposition(cTxtNodes,0,cVPort.y - 16,cVPort.w,16);
	ctlposition(cInfoBtn, cVPort.w+11, 0, 18, 16);
	ctlposition(cSearchStr, -5, cVPort.h+50 , cVPort.w+5, 20);
	ctlposition(cMarkBtn, w - 30, cVPort.h+50, 30, 20);
//	ctlposition(cHelpBtn, w - 22, cVPort.h+28, 16, 16);
	ctlposition(cSelPolysBtn, 10, h - 55, 85, 18);
	ctlposition(cClearBtn, w - 95, h - 55, 85, 18);
}

allClear{
	(,,,t) = time();
	selmode(USER);
	selpolygon(CLEAR);
//	if(selPolysPrev){
//		foreach(pid, selPolysPrev)
//		selpolygon(SET,POLYID,pid);
//	}
	selmode(DIRECT);
		editbegin();
			polysResults=polygons;
		editend();
	(,,,t2) = time();
	gSel=nil; startItem=endItem=0;
	sPolysSelected=string(polysResults.count());
	sTimeElapsed=string("Time elapsed: ", t2-t);
	done=false;
	if(!isTheEnd)	requpdate();
}
sel_ifMarked {
	(,,,t) = time();
	selmode(USER);
	selpolygon(CLEAR);
//	selpolygon(SET,SURFACE,"There is something about jumping a horse over a fence");
	if(gSel==nil || gSel[1]<1 || (!gSel.count()<=1 && startItem==0)) {
		sTimeElapsed=string("Select Something!");
		if(!isTheEnd) requpdate();
		return;
	}
	moninit(gSel.size(), "Doing...");
	if(!isTheEnd){
		sPolysSelected="???";
		sTimeElapsed="Doing...  ";
		requpdate();
	}
	for(j=1;j<=gSel.size();j++) {
		selpolygon(SET,PART,partsArray[gSel[j]]);
		monstep();
	}
	monend();
	selmode(DIRECT);
		editbegin();
			polysResults=polygons;
		editend();
	(,,,t2) = time();
	sPolysSelected=string(polysResults.count());
	sTimeElapsed=string("Time elapsed: ", t2-t);
//	 CommandInput("SEL_POLYGON SET FACE");
//	 CommandInput("SEL_POLYGON SET SURFACE surf2");
//	 CommandInput("SEL_POLYGON SET \"SURFACE\" surf2");
//	 CommandInput("SEL_POLYGON SET COLR Blue");
	done=true;
	if(!isTheEnd)	requpdate();
}
cb_Mark{
	val=getvalue(cSearchStr);
if(val=="")val="^$";
	if(val!=""){
		global_expr = regexp(val);
//		debug();
//		tmp=string(s~,val,~);
//		tmp2=string(global_expr);
//		if(tmp==tmp2) info(true);//The result was Surely TRUE. 
//		info(val, "<br> ", global_expr);//Cant get any from global_expr 
		done=false;
		search_select();
	}
}
InputRefresh : val{
//	val=getvalue(cSearchStr);
	if(val==""){
		val="^$";
		strTimeElapsed="Nothing's gonna change!";
	}
	if(val!=""){
		global_expr = regexp(val);
		done=false;
		search_select();
	}
}
search_select{
	intRowNum=0;
	gSel=nil;
	for(i=1;i<=partsArray.count();i++) {
		if(partsArray[i]==global_expr) gSel[i]=i;
		else gSel[i]=nil;
	}
	gSel.pack();
	gSel.trunc();
	gSel.sortA();//pack and trunc before sorting
	gSel.reduce();//removed neighbourin' duplicated values and nils also. 
	if(gSel.count()<=1 && gSel[1]==nil){
		startItem=0;
		endItem=0;
	}else{ 
		startItem=gSel[1]; 
		endItem=gSel[gSel.count()];
	}
	requpdate();
}

//*****************************************
reqmousedown: md{
var w, h;
	if(cVPort.y>md.y && cVPort.w>md.x){
		help();//requpdate();
		return;
	}
	if(cVPort.x>md.x||(w=cVPort.x+cVPort.w)<md.x||(h=cVPort.y+cVPort.h)<md.y){
		//warn("mouse out of field ",md.x,",",md.y,"<br>",cVPort.x,",",cVPort.y,",",w,",",h);
		requpdate();
		return;
	}
	var keys=md.keys[1]+md.keys[2]+md.keys[3];
	if(md.ctl){//if inside ctlviewport, ctltext, ctlinfo;
		intRowNum=ceil((md.y - md.ctl.y + md.ctl.yoffset)/eachRowH);
		
		if (partsArray.count()>=intRowNum){
			
			if(keys==0){//simple click without any option key*************
				var i;
				for(i=1;i<=gSel.size();i++)gSel[i]=nil;//empty gSel;
				gSel[1]=startItem=endItem=intRowNum;//if out, startItem has been loaded.
			}
			
			else if(keys==2){//Shift**************************
				//Make selection array from startItem to current intRowNum
				for(i=1;i<=gSel.size();i++)gSel[i]=nil;//anyway empty gSel first;
				if(intRowNum<startItem){
					for(i=intRowNum;i<=startItem;i++){
						gSel[i]=i;
					}
				}
				else if(startItem<intRowNum){
					if(startItem==0) startItem=1;//061228mod
					for(i=startItem;i<=intRowNum;i++){
						gSel[i]=i;
					}
				}
				else gSel[1]=startItem=intRowNum;
				endItem=intRowNum;
			}
			
			else if(keys==1){//Ctrl*****************************
				//Add new Item as both start pivot Item
				startItem=endItem=intRowNum;
				if(gSel.contains(intRowNum)){
					for(i=1;i<=gSel.size();i++){
						if(gSel[i]==intRowNum){
							gSel[i]=nil;
						}
					}
				}else{
					gSel[gSel.count() + 1]=intRowNum;
				}
				
			}else if(keys==3){//Ctrl+Shift***************************************
				if(gSel.contains(startItem)){
					var dist, inc;
					if(intRowNum<startItem){
						dist = startItem - intRowNum;
						inc = intRowNum;
						for(i=1;i<=(dist);i++){
							gSel[gSel.size()+i]=inc++;
						}
					}else if(startItem<intRowNum){
						dist = intRowNum - startItem;
						inc = startItem;
						for(i=1;i<=(dist);i++){
							gSel[gSel.size()+i]=++inc;//not inc++;
						}
					}
					endItem=intRowNum;
				}else if(!gSel.contains(startItem)){
					if(intRowNum<startItem){
						for(i=1;i<=gSel.size();i++){
							if(gSel[i]<startItem&&gSel[i]>intRowNum)gSel[i]=nil;
						}
						gSel[++i]=intRowNum;
					}else if(startItem<intRowNum){
						for(i=1;i<=gSel.size();i++){
							if(gSel[i]>startItem&&gSel[i]<intRowNum)gSel[i]=nil;
						}
						gSel[++i]=intRowNum;
					}else if(startItem==intRowNum){
						gSel[gSel.size()+1]=intRowNum;
					}
					endItem=intRowNum;
				}
			}
			//*****************************
			if (md.count==2) {
				if(gSel.contains(startItem)){
					var dist, inc;
					if(intRowNum<startItem){
						dist = startItem - intRowNum;
						inc = intRowNum;
						for(i=1;i<=(dist);i++){
							gSel[gSel.size()+i]=inc++;
						}
					}else if(startItem<intRowNum){
						dist = intRowNum - startItem;
						inc = startItem;
						for(i=1;i<=(dist);i++){
							gSel[gSel.size()+i]=++inc;//not inc++;
						}
					}
					endItem=intRowNum;
				}else if(!gSel.contains(startItem)){
					if(intRowNum<startItem){
						for(i=1;i<=gSel.size();i++){
							if(gSel[i]<startItem&&gSel[i]>intRowNum)gSel[i]=nil;
						}
						gSel[++i]=intRowNum;
					}else if(startItem<intRowNum){
						for(i=1;i<=gSel.size();i++){
							if(gSel[i]>startItem&&gSel[i]<intRowNum)gSel[i]=nil;
						}
						gSel[++i]=intRowNum;
					}else if(startItem==intRowNum){
						gSel[gSel.size()+1]=intRowNum;
					}
					endItem=intRowNum;
				}	
				/////////////
				gSel.pack();
				gSel.trunc();
				gSel.sortA();//pack and trunc before sorting
				gSel.reduce();//removed neighbourin' duplicated values and nils also. 
				sCSA=string(CSA(keys));
				sLMR=LMR(md.button);
				sRowNum=string(intRowNum);
				iMouCount=md.count;
				done=false;
				reqabort(true);//search_select();
			}
			gSel.pack();
			gSel.trunc();
			gSel.sortA();//pack and trunc before sorting
			gSel.reduce();//removed neighbourin' duplicated values and nils also. 
			sCSA=string(CSA(keys));
			sLMR=LMR(md.button);
			sRowNum=string(intRowNum);
			iMouCount=md.count;
			requpdate();//give a shock on the vp_redraw func.
		}
	}
}
//*****************************************
vp_redraw: ctl{
	vpTextW=drawtextwidth(Tags[iLongestTag]);
	lineNum=partsArray.count();
	dynH=lineNum*eachRowH;
	if(dynH<cVPort.h)dynH=cVPort.h;
	drawbox(<130,130,130>,0,0,iCanvW,dynH);
	intContains=0;intNotContains=0;
	for(i=1;i<=lineNum;i++){
		if(gSel.contains(i)){
//			drawbox(<160,160,160>,0,(i - 1)*eachRowH +1, cVPort.w - 1,eachRowH);
			drawbox(<70,64,180>,0,(i - 1)*eachRowH +1, iCanvW,eachRowH);
			drawtext(string("      ",partsArray[i]),<210,200,180>,0,(i - 1)*eachRowH+iStrOffsetY);
			drawline(<110,110,210>,0,i*eachRowH,iCanvW,i*eachRowH);
			intContains++;
		}
		if(!gSel.contains(i)){
			drawtext(string("      ",partsArray[i]),<50,50,50>,0,(i - 1)*eachRowH+iStrOffsetY);
			drawline(<110,110,210>,0,i*eachRowH,iCanvW,i*eachRowH);
			intNotContains++;
		}
		if(i==startItem)drawtext(string(" s   "),<0,255,0>,0,(i - 1)*eachRowH+iStrOffsetY);
		if(i==endItem)drawtext(string("   e "),<255,0,0>,0,(i - 1)*eachRowH+iStrOffsetY);
	}
	//dynamic border shift etc.
	drawline(<110,110,250>,20,0,20,(partsArray.count()*eachRowH - 1));//a vertical colum line
	drawborder(ctl.xoffset,ctl.yoffset,cVPort.w,cVPort.h, true);//3d edge around viewport
	//Do setvalue any except nil.
	if(gSel.count()==0) gSel=nil;
	//debug Info
	if(gInfo){
		if(gSel!=nil && intRowNum>0 && intRowNum<=lineNum){
			sw=string(sCSA, " ", sLMR, " x", iMouCount, " Clicked!");
			drawbox(<255,200,0>,21,(intRowNum - 1)*eachRowH +1, drawtextwidth(sw)+2,eachRowH - 2);
			drawtext(sw,<50,50,50>,20, (intRowNum - 1)*eachRowH+iStrOffsetY);
		}
		sad=string("Add. in dec. ");
		drawtext(sad, <0,0,0>, ctl.xoffset+(cVPort.w -drawtextwidth(sad) - 1), ctl.yoffset+101);
		drawtext(sad,<210, 220, 250>, ctl.xoffset+(cVPort.w -drawtextwidth(sad) - 2), ctl.yoffset+100);
		pl=string("PART[0]: "+  offsetToPart0 + ", LAYR[0]: "+ iLoL);
		drawtext(pl, <0,0,0>, ctl.xoffset+(cVPort.w -drawtextwidth(pl) - 1), ctl.yoffset+117);
		drawtext(pl, <200, 200, 240>, ctl.xoffset+(cVPort.w -drawtextwidth(pl) - 2), ctl.yoffset+116);
		sSrf=string("Surfs count: ", surfTagsSize);
		drawtext(sSrf, <0,0,0>,ctl.xoffset+(cVPort.w -drawtextwidth(sSrf) - 1),ctl.yoffset+133);
		drawtext(sSrf, <200, 200, 240>,ctl.xoffset+(cVPort.w -drawtextwidth(sSrf) - 2),ctl.yoffset+132);
	}
//		pc=string("Adv. ",selPolysPrev.count());
//		drawtext(pc, <220, 200, 150>,ctl.xoffset+( cVPort.w - drawtextwidth(pc) - 2), ctl.yoffset+2);

		if(sTimeElapsed)
		drawtext(sTimeElapsed,<255, 255, 255>,ctl.xoffset + (cVPort.w - drawtextwidth(sTimeElapsed) - 2), ctl.yoffset + (cVPort.h - 16));
}
//*****************************************
vp_Canvas_size: ctl
{
	if(cVPort.w > integer(6.5*iLongestName))
		iCanvW=cVPort.w;
	else
		iCanvW=integer(6.5*iLongestName);
	if (vpTextW){	
		if(cVPort.w >(vpTextW+32))
			iCanvW=cVPort.w;
		else
			iCanvW=vpTextW+32;
	}
	if(gInfo)
		iCanvW=400;
	return(iCanvW,(partsArray.count()*eachRowH+iStrOffsetY));
}
//*****************************************
info_redraw{

	drawbox(<80,80,80>,0,0,cVPort.w,eachRowH);
	drawline(<0,0,0>,1,0,cVPort.w,0);// - top horizontal border
	drawline(<255,0,0>,0,eachRowH,cVPort.w,eachRowH);// _ bottom horizontal border
	drawline(<0,0,0>,0,0,0,eachRowH);//| left vertical border
	drawline(<200,200,200>,cVPort.w - 1,0,cVPort.w - 1,eachRowH);//right vertical border |
	if(gInfo)
	{
		drawfillcircle(<0,0,50>,<255,200,100>, eachRowH/2, eachRowH/2, 4);
	}
	else drawfillcircle(<0,0,100>,<180,255,200>, eachRowH/2, eachRowH/2, 4);
	drawtext(string("     Parts"),<0,0,0>,1,1);
	drawtext(string("     Parts"),<0,0,0>,0,2);
	drawtext(string("     Parts"),<0,0,0>,2,2);
	drawtext(string("     Parts"),<0,0,0>,0,3);
	drawtext(string("     Parts"),<0,0,0>,1,3);
	drawtext(string("     Parts"),<0,0,0>,2,3);
	drawtext(string("     Parts"),<200,150,255>,1,2);
	drawtext(string(gSel.count(), " /",  partsArray.size()), <0,0,0>,56,3);
	drawtext(string(gSel.count(), " /",  partsArray.size()), <200,150,255>,55,2);
	drawtext(string(gSel.count()), <2550,200,100>,55,2);
	sp=string("Polys ", sPolysSelected);
	drawtext(sp,<180, 200, 220>,cVPort.w - drawtextwidth(sp) - 2,2);
	//drawborder(0,0,cVPort.w - 1,eachRowH,true);
}
CSA: keys{
	switch(keys){
		case 0:return "";
		case 1: return "Ctrl";
		case 2:return "Shift";
		case 3:return "Ctrl+Shift";
		case 4:return "Alt";
		case 5:return "Ctrl+Alt";
		case 6:return "Shift+Alt";
		case 7:return "Ctrl+Shift+Alt";
		default: return "keyName func Error.";
	}
}
LMR: btn{
	switch(btn){
		case 0:return "btnName func got Zero";
		case 1: return "Lmb";
		case 2:return "Mmb";
		case 3:return "Rmb";
		default: return "btnName func Error.";
	}
}
infoStatus : bl{
	gInfo=bl;
//	setvalue(cSearchStr,"^.+$");
	requpdate();
}
help{
	info("sel_Multi_Parts.LS: Ver..69, (c) 2007 ArturoSeth@gmail.com<br>
Am Not Responsible for Any Damage on Your Intellectual Data!!");
}
